// Copyright 2019 Orus. All rights reserved.

package main

import (
	"github.com/spf13/cobra"
	xbus "xbus.io/go-xbus/v4"
	xbusCmd "xbus.io/go-xbus/v4/cmd"
	_ "xbus.io/go-xbus/v4/demo"

	_ "orus.io/xbus/xbus-stdlib/filegateway"
	stdlib "orus.io/xbus/xbus-stdlib/lib"
	_ "orus.io/xbus/xbus-stdlib/routing"
	_ "orus.io/xbus/xbus-stdlib/xbus2xbus"
)

// Version of xbus-stdlib
const Version = "1.3.5"

func init() {
	cobra.OnInitialize(initConfig)
}

func initConfig() {
	if err := stdlib.LoadS3Endpoints(xbusCmd.Viper.GetStringMap("file-location.s3")); err != nil {
		xbusCmd.Logger.Err(err).Msg("Could not load file-location.s3 settings")
	}
}

func main() {
	// Fiddle with the command declared by go-xbus.
	xbusCmd.RootCmd.Use = "xbus-stdlib"
	xbusCmd.RootCmd.Short = ""
	xbusCmd.RootCmd.Long = ""
	xbus.ClientName = ""
	xbus.ClientVersion = Version
	xbusCmd.SetupVersionFlag()
	xbusCmd.Execute()
}
